=== modified file 'bzrlib/controldir.py'
--- bzrlib/controldir.py	2010-08-02 12:31:49 +0000
+++ bzrlib/controldir.py	2010-08-02 12:55:10 +0000
@@ -664,7 +664,7 @@
 
     def probe_transport(self, transport):
         """Return the controldir style format present in a directory."""
-        raise NotImplementedError(klass.probe_transport)
+        raise NotImplementedError(self.probe_transport)
 
 
 probers = []

=== modified file 'bzrlib/smart/bzrdir.py'
--- bzrlib/smart/bzrdir.py	2010-05-06 23:41:35 +0000
+++ bzrlib/smart/bzrdir.py	2010-08-02 12:55:10 +0000
@@ -22,6 +22,7 @@
     BzrDir,
     BzrDirFormat,
     BzrDirMetaFormat1,
+    BzrProber,
     network_format_registry,
     )
 from bzrlib.smart.request import (
@@ -44,10 +45,9 @@
             # clients that don't anticipate errors from this method.
             answer = 'no'
         else:
-            default_format = BzrDirFormat.get_default_format()
-            real_bzrdir = default_format.open(t, _found=True)
+            bzr_prober = BzrProber()
             try:
-                real_bzrdir._format.probe_transport(t)
+                bzr_prober.probe_transport(t)
             except (errors.NotBranchError, errors.UnknownFormatError):
                 answer = 'no'
             else:

=== modified file 'bzrlib/tests/test_foreign.py'
--- bzrlib/tests/test_foreign.py	2010-08-02 12:31:49 +0000
+++ bzrlib/tests/test_foreign.py	2010-08-02 12:55:10 +0000
@@ -192,10 +192,6 @@
     """BzrDirFormat for the dummy foreign VCS."""
 
     @classmethod
-    def get_format_string(cls):
-        return "A Dummy VCS Dir"
-
-    @classmethod
     def get_format_description(cls):
         return "A Dummy VCS Dir"
 
@@ -206,13 +202,6 @@
     def get_branch_format(self):
         return DummyForeignVcsBranchFormat()
 
-    @classmethod
-    def probe_transport(klass, transport):
-        """Return the .bzrdir style format present in a directory."""
-        if not transport.has('.dummy'):
-            raise errors.NotBranchError(path=transport.base)
-        return klass()
-
     def initialize_on_transport(self, transport):
         """Initialize a new bzrdir in the base directory of a Transport."""
         # Since we don't have a .bzr directory, inherit the
@@ -270,6 +259,8 @@
     controldir.ControlDirFormat.register_format(DummyForeignVcsDirFormat)
     testcase.addCleanup(controldir.ControlDirFormat.unregister_format,
                         DummyForeignVcsDirFormat)
+    controldir.probers.append(DummyForeignProber)
+    testcase.addCleanup(controldir.probers.remove, DummyForeignProber)
     # We need to register the optimiser to make the dummy appears really
     # different from a regular bzr repository.
     branch.InterBranch.register_optimiser(InterToDummyVcsBranch)
@@ -277,6 +268,16 @@
                         InterToDummyVcsBranch)
 
 
+class DummyForeignProber(controldir.Prober):
+
+    @classmethod
+    def probe_transport(klass, transport):
+        """Return the .bzrdir style format present in a directory."""
+        if not transport.has('.dummy'):
+            raise errors.NotBranchError(path=transport.base)
+        return DummyForeignVcsDirFormat()
+
+
 class ForeignVcsRegistryTests(tests.TestCase):
     """Tests for the ForeignVcsRegistry class."""
 

